UNIT Comp;

{$mode objfpc}{$H+}

INTERFACE

USES
  Classes, Base, Scan, Expr, Parser, Files, SysUtils,Dialogs;

  FUNCTION  Compile(AName: Base.TStrings; TextAddr: Pointer; Len: INTEGER): BOOLEAN;
  PROCEDURE Parse(AName: Base.TStrings; TextAddr: Pointer);

IMPLEMENTATION

USES
  Main, DocManager;

PROCEDURE Module(AName: string);
VAR
  key: LONGINT;
  impid, impid1: Base.TIdent;
  sl: TStringList;
  ed: TXSSynEdit;
  path, ext, name: string;
BEGIN

  Scan.Get(sym);
  IF sym = Scan.lx_module THEN BEGIN

    Scan.Get(sym);
    IF sym = Scan.lx_times THEN Scan.Get(sym);

    IF sym = Scan.lx_ident THEN BEGIN
      Scan.Get(sym);
    END ELSE
      Base.Mark('identifier expected');

    Expr.Check(Scan.lx_semicolon, 'no ;');

    IF sym = Scan.lx_import THEN BEGIN

      Scan.Get(sym);

      WHILE sym = Scan.lx_ident DO BEGIN
        impid := Scan.id;
        Scan.Get(sym);
        IF sym = Scan.lx_becomes THEN BEGIN
          Scan.Get(sym);
          IF sym = Scan.lx_ident THEN BEGIN
            impid1 := Scan.id;
            Scan.Get(sym);
          END ELSE
            Base.Mark('id expected');
        END ELSE
          impid1 := impid;

        IF impid1 <> 'SYSTEM' THEN BEGIN
          IF NOT Scan.Find(impid1) THEN BEGIN

            path := ExtractFilePath(AName);
            ext  := ExtractFileExt(AName);
            name := path+impid1+ext;

            ed := Form1.Document.FindEditorByPageName(name);

            IF (ed<>NIL) OR ((ed=NIL) AND FileExists(name)) THEN BEGIN

              IF Base.errcnt = 0 THEN BEGIN
                Scan.Push(sym);
                Scan.Add(impid1);
                IF ed = NIL THEN BEGIN
                  sl := TStringList.Create;
                  sl.LoadFromFile(name);
                  Parse(name,@sl.Text[1]);
                  key := Base.HASH(@sl.Text[1],length(sl.Text));
                  IF key <> Files.ReadKey(path+Base.objdir+impid1+Base.symext) THEN
                    Parser.Compile(name,@sl.Text[1],key);
                  sl.free;
                END ELSE BEGIN
                  Parse(name,@ed.Text[1]);
                  key := Base.HASH(@ed.Text[1],length(ed.Text));
                  IF key <> Files.ReadKey(path+Base.objdir+impid1+Base.symext) THEN
                    Parser.Compile(name,@ed.Text[1],key);
                END;
                Scan.Pop(sym);
              END;

            END ELSE
              Base.Mark('file not found');

          END;
        END;

        IF sym = Scan.lx_comma THEN
          Scan.Get(sym)
        ELSE IF sym = Scan.lx_ident THEN
          Base.Mark('comma missing');
      END;

      Expr.Check(Scan.lx_semicolon, 'no ;');

    END;

  END;

END;

PROCEDURE Parse(AName: Base.TStrings; TextAddr: Pointer);
BEGIN
  Scan.Init(AName,TextAddr);
  Module(AName);
END;

FUNCTION Compile(AName: Base.TStrings; TextAddr: Pointer; Len: INTEGER): BOOLEAN;
BEGIN
  Form1.msgview.Clear;
  Parse(AName,TextAddr);
  Scan.Clear;
  IF Base.errcnt = 0 THEN Parser.Compile(AName,TextAddr,Base.HASH(TextAddr,Len));
  RESULT := Base.errcnt = 0;
END;

END.

