UNIT Files;

{$mode objfpc}{$H+}

INTERFACE

USES
  Classes, SysUtils, Dialogs, Base;

TYPE
  RscData = RECORD
    data, str, code: POINTER;
    entry, pc, varsize, strx, tdx, size, key, nofent: LONGINT;
    fixorgP, fixorgD, fixorgT : LONGINT;
  END;

  PROCEDURE Decode(filename: STRING; VAR s: STRING);
  PROCEDURE Export(AName: Base.TStrings; VAR modid: Base.TIdent; VAR newSF: BOOLEAN; key: LONGINT);
  PROCEDURE Import(AName: Base.TStrings; VAR modid, modid1: Base.TIdent);
  PROCEDURE CreateRsc(AName: Base.TStrings; VAR modid: Base.TIdent; VAR d: RscData);
  FUNCTION  ReadKey(AName: Base.TStrings): INTEGER;

IMPLEMENTATION

VAR
  mnemo0, mnemo1: ARRAY [0..16-1] OF ARRAY [0..5-1] OF CHAR;

FUNCTION Len(VAR name: Base.TIdent): INTEGER;
BEGIN
  RESULT := 0;
  WHILE (RESULT<Base.BufSize) AND (name[RESULT]<>#0) DO INC(RESULT);
  IF RESULT > 0 THEN BEGIN INC(RESULT); name[RESULT] := #0; END;
END;

FUNCTION ASH (e, bit : INTEGER): INTEGER;
BEGIN
  IF bit < 0 THEN e := e SHR SYSTEM.ABS(bit) ELSE e := e SHL bit;
  RESULT:=e;
END;

PROCEDURE WriteNum(VAR F: TFileStream; x: INTEGER);
BEGIN
  WHILE (x<-$40) OR (x>=$40) DO BEGIN
    F.WriteByte(_MOD(x,$80) + $80);
    x := _DIV(x,$80);
  END;
  F.WriteByte(_MOD(x,$80));
END;

PROCEDURE Read(VAR F: TFileStream; VAR x: INTEGER);
VAR
  b: SHORTINT;
BEGIN
  F.Read(b,1);
  IF b < $80 THEN x := b ELSE x := b - $100;
END;

PROCEDURE ReadNum(VAR F: TFileStream; VAR x: INTEGER);
VAR
  n: LONGINT;
  s: SHORTINT;
  ch: CHAR;
BEGIN
  s := 0;
  n := 0;
  F.Read(ch,1);
  WHILE ORD(ch) >= $80 DO BEGIN
    INC(n, ASH(ORD(ch) - $80, s) );
    INC(s, 7);
    F.Read(ch,1)
  END;
  x := n + ASH(_MOD(ORD(ch),$40) - _DIV(ORD(ch),$40) * $40, s);
END;

PROCEDURE ReadInt(VAR F: TFileStream; VAR x: INTEGER);
VAR
  x0, x1, x2, x3: BYTE;
BEGIN
  x0 := F.ReadByte;
  x1 := F.ReadByte;
  x2 := F.ReadByte;
  x3 := F.ReadByte;
  x := ((x3 * $100 + x2) * $100 + x1) * $100 + x0;
END;

PROCEDURE ReadString(VAR F: TFileStream; VAR x: ARRAY OF CHAR);
VAR
  i: INTEGER;
  ch: CHAR;
BEGIN
  i := 0;
  F.Read(ch,1);
  WHILE ch <> #0 DO BEGIN
    IF i < length(x)-1 THEN BEGIN x[i] := ch; INC(i) END;
    F.Read(ch,1);
  END ;
  x[i] := #0;
END;

(**************************************)

PROCEDURE InType(VAR F: TFileStream; thismod: Base.Object_; VAR T: Base.Type_);
VAR
  key: LONGINT;
  ref, clas, form, np, readonly: INTEGER;
  fld, par, obj, amod: Base.Object_;
  tp: Base.Type_;
  name, modname: Base.TIdent;
BEGIN

  Read(F, ref);

  IF ref < 0 THEN
    T := Base.typtab[-ref]
  ELSE BEGIN
    tp := Base.Type_.Create;
    T := tp;
    typtab[ref] := tp;
    tp.mno := thismod.lev;
    Read(F, form);
    tp.form := form;
    Base.objlist.Add(tp);

    IF form = Base.fPointer THEN BEGIN
      InType(F, thismod, tp.base);
      tp.size := 4
    END ELSE IF form = Base.fArray THEN BEGIN
      InType(F, thismod, tp.base);
      ReadNum(F, tp.len);
      ReadNum(F, tp.size)
    END ELSE IF form = Base.fRecord THEN BEGIN

      InType(F, thismod, tp.base);

      IF tp.base.form = Base.fNoTyp THEN BEGIN
        tp.base := NIL;
        obj := NIL
      END ELSE
        obj := tp.base.dsc;

      ReadNum(F, tp.len);
      ReadNum(F, tp.nofpar);
      ReadNum(F, tp.size);
      Read(F, clas);

      WHILE clas <> 0 DO BEGIN
        fld := Base.Object_.Create;
        fld.clas := clas;
        Base.objlist.Add(fld);
        ReadString(F,fld.name);
        IF fld.name[0] <> #0 THEN BEGIN
          fld.expo := TRUE;
          InType(F, thismod, fld.typ)
        END ELSE BEGIN
          fld.expo := FALSE;
          fld.typ  := Base.nilType
        END;
        ReadNum(F, fld.val);
        fld.next := obj;
        obj := fld;
        Read(F,clas);
      END;

      tp.dsc := obj;

    END ELSE IF form = Base.fProc THEN BEGIN
      InType(F, thismod, tp.base);
      obj := NIL;
      np := 0;
      Read(F, clas);
      WHILE clas <> 0 DO BEGIN
        par := Base.Object_.Create;
        par.clas := clas;
        Base.objlist.Add(par);
        Read(F, readonly);
        par.rdo := readonly = 1;
        InType(F, thismod, par.typ);
        par.next := obj;
        obj := par;
        INC(np);
        Read(F, clas);
      END ;
      tp.dsc := obj;
      tp.nofpar := np;
      tp.size := 4;
    END;

    ReadString(F,modname);

    IF modname[0] <>  #0 THEN BEGIN
      F.Read(key,4);
      ReadString(F,name);
      amod := ThisModule(modname, modname, FALSE, key);
      obj := amod.dsc;
      WHILE (obj <> NIL) AND (obj.name <> name) DO obj := obj.next;
      IF obj <> NIL THEN
        T := obj.typ
      ELSE BEGIN
        obj := Base.Object_.Create;
        obj.name := name;
        obj.clas := Base.cTyp;
        obj.next := amod.dsc;
        Base.objlist.Add(obj);
        amod.dsc := obj;
        obj.typ  := tp;
        tp.mno    := amod.lev;
        tp.typobj := obj;
        T := tp;
      END ;
      typtab[ref] := T;
    END;

  END;

END;

PROCEDURE Import(AName: Base.TStrings; VAR modid, modid1: Base.TIdent);
VAR
  key: LONGINT;
  clas, k: INTEGER;
  obj: Base.Object_;
  t  : Base.Type_;
  thismod: Base.Object_;
  modname: Base.TIdent;
  fname, dir: Base.TStrings;
  F: TFileStream;
BEGIN

  dir := ExtractFilePath(AName);
  fname := dir+Base.objdir+modid1+Base.symext;

  IF FileExists(fname) THEN BEGIN

    F:= TFileStream.Create(fname,fmOpenRead);
    F.Seek(0,soBeginning);
    F.Read(key,4);
    F.Read(key,4);
    ReadString(F,modname);
    thismod     := Base.ThisModule(modid,modid1,TRUE,key);
    thismod.rdo := TRUE;
    Read(F,clas);

    IF clas <> Base.versionkey THEN Base.Mark('wrong version');

    Read(F, clas);

    WHILE clas <> 0 DO BEGIN
      obj := Base.Object_.Create;
      obj.clas := clas;
      Base.objlist.Add(obj);
      ReadString(F,obj.name);
      InType(F, thismod, obj.typ);
      obj.lev := -thismod.lev;
      IF clas = Base.cTyp THEN BEGIN
        t := obj.typ;
        t.typobj := obj;
        Read(F, k);
        WHILE k <> 0 DO BEGIN
          typtab[k].base := t;
          Read(F, k)
        END;
      END ELSE BEGIN
        IF clas = Base.cConst THEN BEGIN
          IF obj.typ.form = Base.fReal THEN
            F.Read(obj.val,4)
          ELSE
            ReadNum(F, obj.val);
        END ELSE IF clas = Base.cVar THEN BEGIN
          ReadNum(F, obj.val);
          obj.rdo := TRUE;
        END;
      END;
      obj.next := thismod.dsc;
      thismod.dsc := obj;
      Read(F, clas);
    END;

    F.free;

  END ELSE
    Base.Mark('import not available');

END;

(******************************************)
(******************************************)
(******************************************)

PROCEDURE OutType(VAR F: TFileStream; t: Base.Type_);
VAR
  obj, amod, fld: Base.Object_;

  PROCEDURE OutPar(VAR F: TFileStream; par: Base.Object_; n: INTEGER);
  VAR
    cl: INTEGER;
  BEGIN
    IF n > 0 THEN BEGIN
      OutPar(F, par.next, n-1);
      cl := par.clas;
      F.WriteByte(cl);
      IF par.rdo THEN
        F.WriteByte(1)
      ELSE
        F.WriteByte(0);
      OutType(F, par.typ)
    END;
  END;

  PROCEDURE FindHiddenPointers(VAR F: TFileStream; typ: Base.Type_; offset: LONGINT);
  VAR
    fld: Base.Object_;
    i, n: LONGINT;
  BEGIN
    IF (typ.form = Base.fPointer) OR (typ.form = Base.fNilTyp) THEN BEGIN
      F.WriteByte(Base.cFld);
      F.WriteByte(0);
      WriteNum(F, offset);
    END ELSE IF typ.form = Base.fRecord THEN BEGIN
      fld := typ.dsc;
      WHILE fld <> NIL DO BEGIN
        FindHiddenPointers(F, fld.typ, fld.val + offset);
        fld := fld.next
      END;
    END ELSE IF typ.form = Base.fArray THEN BEGIN
      i := 0;
      n := typ.len;
      WHILE i < n DO BEGIN
        FindHiddenPointers(F, typ.base, typ.base.size * i + offset);
        INC(i);
      END;
    END;
  END;

BEGIN

  IF t.ref > 0 THEN
    F.WriteByte(-t.ref)
  ELSE BEGIN

    obj := t.typobj;

    IF obj <> NIL THEN BEGIN
      F.WriteByte(Ref);
      t.ref := Ref;
      INC(Ref)
    END ELSE
      F.WriteByte(0);

    F.WriteByte(t.form);

    IF t.form = Base.fPointer THEN
      OutType(F,t.base)
    ELSE IF t.form = Base.fArray THEN BEGIN
      OutType(F, t.base);
      WriteNum(F,t.len);
      WriteNum(F,t.size);
    END ELSE IF t.form = Base.fRecord THEN BEGIN

      IF t.base <> NIL THEN
        OutType(F, t.base)
      ELSE
        OutType(F, noType);

      IF obj <> NIL THEN
        WriteNum(F, obj.exno)
      ELSE
        F.WriteByte(0);

      WriteNum(F, t.nofpar);
      WriteNum(F, t.size);

      fld := t.dsc;
      WHILE fld <> NIL DO BEGIN
        IF fld.expo THEN BEGIN
          F.WriteByte(Base.cFld);
          F.Write(fld.name,Len(fld.name));
          OutType(F, fld.typ);
          WriteNum(F, fld.val);
        END ELSE
          FindHiddenPointers(F, fld.typ, fld.val);
        fld := fld.next
      END ;
      F.WriteByte(0);

    END ELSE IF t.form = Base.fProc THEN BEGIN
      OutType(F, t.base);
      OutPar(F, t.dsc, t.nofpar);
      F.WriteByte(0);
    END;

    IF (t.mno > 0) AND (obj <> NIL) THEN BEGIN
      amod := Base.topScope.next;
      WHILE (amod <> NIL) AND (amod.lev <> t.mno) DO amod := amod.next;
      IF amod <> NIL THEN BEGIN
        F.Write(amod.name,Len(amod.name));
        F.Write(amod.val,4);
        F.Write(obj.name,Len(obj.name))
      END ELSE BEGIN
        Base.Mark('re-export not found');
        F.WriteByte(0);
      END;
    END ELSE
      F.WriteByte(0);

  END;

END;

FUNCTION ReadKey(AName: Base.TStrings): INTEGER;
VAR
  F: TFileStream;
BEGIN
  IF FileExists(AName) THEN BEGIN
    F := TFileStream.Create(AName,fmOpenRead);
    F.Seek(4,soBeginning);
    F.Read(RESULT,4);
    F.free;
  END ELSE
    RESULT := -1;
END;

PROCEDURE Export(AName: Base.TStrings; VAR modid: Base.TIdent; VAR newSF: BOOLEAN; key: LONGINT);
VAR
  x, sum, oldkey: LONGINT;
  obj, obj0: Object_;
  filename,dir: Base.TStrings;
  tmp : INTEGER;
  F: TFileStream;
BEGIN

  dir := ExtractFilePath(AName);
  IF NOT DirectoryExists(dir+Base.objdir) THEN CreateDir(dir+Base.objdir);
  filename := dir+Base.objdir+modid+Base.symext;

  newSF := TRUE;
  IF FileExists(filename) THEN BEGIN
    tmp := ReadKey(filename);
    IF tmp = key THEN newSF := FALSE;
  END;

  IF newSF THEN BEGIN

    Base.Ref := Base.fRecord + 1;
    F := TFileStream.Create(filename,fmCreate);
    F.Seek(0,soBeginning);
    tmp := 0;
    F.Write(tmp,4);
    F.Write(tmp,4);
    F.Write(modid,Len(modid));
    F.WriteByte(Base.versionkey);

    obj := Base.topScope.next;

    WHILE obj <> NIL DO BEGIN
      IF obj.expo THEN BEGIN
        F.Write(obj.clas,1);
        F.Write(obj.name,Len(obj.name));
        OutType(F, obj.typ);
        IF obj.clas = Base.cTyp THEN BEGIN
          IF obj.typ.form = Base.fRecord THEN BEGIN
            obj0 := Base.topScope.next;
            WHILE obj0 <> obj DO BEGIN
              IF (obj0.typ.form = Base.fPointer) AND (obj0.typ.base = obj.typ)
              AND (obj0.typ.ref > 0) THEN
                F.WriteByte(obj0.typ.ref);
              obj0 := obj0.next;
            END;
          END;
          F.WriteByte(0);
        END ELSE IF obj.clas = Base.cConst THEN BEGIN
          IF      obj.typ.form = Base.fProc THEN WriteNum(F, obj.exno)
          ELSE IF obj.typ.form = Base.fReal THEN F.Write(obj.val,4)
          ELSE                                   WriteNum(F, obj.val);
        END ELSE IF obj.clas = Base.cVar THEN
          WriteNum(F, obj.exno);
      END;
      obj := obj.next;
    END;

    REPEAT
      F.WriteByte(0);
    UNTIL _MOD(F.Position,4) = 0;

    newSF := TRUE;
    F.Seek(4,soBeginning);
    F.Write(key,4);

    F.free;
  END;

END;

(******************************************)
(******************************************)
(******************************************)

PROCEDURE FindPtrs(VAR F: TFileStream; typ: Base.Type_; adr: LONGINT);
VAR
  fld: Base.Object_;
  i, s: LONGINT;
BEGIN
  IF (typ.form = Base.fPointer) OR (typ.form = Base.fNilTyp) THEN
    F.Write(adr,4)
  ELSE IF typ.form = Base.fRecord THEN BEGIN
    fld := typ.dsc;
    WHILE fld <> NIL DO BEGIN
      FindPtrs(F, fld.typ, fld.val + adr);
      fld := fld.next
    END;
  END ELSE IF typ.form = Base.fArray THEN BEGIN
    s := typ.base.size;
    FOR i := 0 TO typ.len-1 DO FindPtrs(F, typ.base, i*s + adr);
  END;
END;

PROCEDURE CreateRsc(AName: Base.TStrings; VAR modid: Base.TIdent; VAR d: RscData);
VAR
  name,dir: Base.TStrings;
  obj : Base.Object_;
  F   : TFileStream;
  tmp : INTEGER;
BEGIN

  dir := ExtractFilePath(AName);
  IF NOT DirectoryExists(dir+Base.objdir) THEN CreateDir(dir+Base.objdir);
  name := dir+Base.objdir+modid+Base.objext;

  F := TFileStream.Create(name,fmCreate);
  F.Seek(0,soBeginning);
  F.Write(modid,Len(modid));
  F.Write(d.key,4);
  F.WriteByte(Base.versionkey);
  F.Write(d.size,4);

  obj := Base.topScope.next;
  WHILE (obj <> NIL) AND (obj.clas = Base.cMod) DO BEGIN
    IF obj.dsc <> Base.vsystem THEN BEGIN
      F.Write(Base.Module_(obj).orgname,Len(Base.Module_(obj).orgname));
      F.Write(obj.val,4);
    END;
    obj := obj.next;
  END ;

  F.WriteByte(0);
  tmp := d.tdx*4;
  F.Write(tmp,4);

  F.Write(d.data^,d.tdx*4);
  tmp := d.varsize - d.tdx*4;
  F.Write(tmp,4);

  F.Write(d.strx,4);
  F.Write(d.str^,d.strx);

  F.Write(d.pc,4);
  F.Write(d.code^,d.pc*4);

  obj := Base.topScope.next;
  WHILE obj <> NIL DO BEGIN
    IF (obj.exno <> 0) AND (obj.clas = Base.cConst) AND (obj.typ.form = Base.fProc)
    AND (obj.typ.nofpar = 0) AND (obj.typ.base = Base.noType) THEN BEGIN
      F.Write(obj.name,Len(obj.name));
      F.Write(obj.val,4);
    END;
    obj := obj.next;
  END ;

  F.WriteByte(0);
  F.Write(d.nofent,4);
  F.Write(d.entry,4);

  obj := Base.topScope.next;
  WHILE obj <> NIL DO BEGIN
    IF obj.exno <> 0 THEN BEGIN
      IF (obj.clas = Base.cConst) AND (obj.typ.form = Base.fProc) OR (obj.clas = Base.cVar) THEN
        F.Write(obj.val,4)
      ELSE IF obj.clas = Base.cTyp THEN BEGIN
        IF obj.typ.form = Base.fRecord THEN
          F.Write(_MOD(obj.typ.len,$10000),4)
        ELSE IF (obj.typ.form = Base.fPointer) AND ((obj.typ.base.typobj = NIL) OR (obj.typ.base.typobj.exno = 0)) THEN
          F.Write(_MOD(obj.typ.base.len,$10000),4)
      END;
    END;
    obj := obj.next;
  END;

  obj := Base.topScope.next;
  WHILE obj <> NIL DO BEGIN
    IF obj.clas = Base.cVar THEN FindPtrs(F, obj.typ, obj.val);
    obj := obj.next;
  END ;

  tmp := -1;
  F.Write(tmp,4);
  F.Write(d.fixorgP,4);
  F.Write(d.fixorgD,4);
  F.Write(d.fixorgT,4);
  F.Write(d.entry,4);
  F.WriteByte(ORD('O'));

  F.free;
END;

(******************************************)
(******************************************)
(******************************************)

PROCEDURE WriteReg(r: LONGINT; VAR s: STRING);
BEGIN
  s := s + ' ';
  IF          r < 12 THEN BEGIN s := s + 'R'; s := s + IntToStr(_MOD(r,$10));
    IF _MOD(r,$10)<10 THEN      s := s + ' ';
  END ELSE IF r = 12 THEN       s := s + 'MT '
  ELSE     IF r = 13 THEN       s := s + 'SB '
  ELSE     IF r = 14 THEN       s := s + 'SP '
  ELSE                          s := s + 'LNK';
END;

PROCEDURE Opcode(w: LONGINT; VAR s: STRING);
VAR
  k, op, u, a, b, c, x: LONGINT;
BEGIN

  k  := _MOD(_DIV(w,$40000000),4  );
  a  := _MOD(_DIV(w,$1000000) ,$10);
  b  := _MOD(_DIV(w,$100000)  ,$10);
  op := _MOD(_DIV(w,$10000)   ,$10);
  c  := _MOD(     w,$10           );
  u  := _MOD(_DIV(w,$20000000),2  );

  s := s + ' ';

  IF k = 0 THEN BEGIN
    s := s + mnemo0[op];
    IF u = 1 THEN s := s + '''' ELSE s := s + ' ';
    WriteReg(a,s); WriteReg(b,s); WriteReg(c,s);
  END ELSE IF k = 1 THEN BEGIN
    s := s + mnemo0[op];
    IF u = 1 THEN s := s + '''' ELSE s := s + ' ';
    WriteReg(a,s); WriteReg(b,s); w := _MOD(w,$10000);
    IF w >= $8000 THEN w := w - $10000;
    s := s + ' ' + IntToStr(w);
  END ELSE IF k = 2 THEN BEGIN (*LDR/STR*)
    IF u = 1 THEN s := s + 'STR '
    ELSE          s := s + 'LDR ';
    WriteReg(a,s); WriteReg(b,s);
    w := _MOD(w,$100000);
    IF w >= $80000 THEN w := w - $100000;
    s := s + ' '+IntToStr(w);
  END ELSE IF k = 3 THEN BEGIN (*Branch instr*)
    x := length(s);
    s := s + 'B';
    IF ODD(_DIV(w ,$10000000)) THEN s := s + 'L';
    s := s + mnemo1[a];
    IF u = 0 THEN
      WriteReg(c,s)
    ELSE BEGIN
      w := _MOD(w,$100000);
      IF w >= $80000 THEN w := w - $100000;
      s := s + ' ' + IntToStr(w);
    END;
  END;

END;

PROCEDURE Decode(filename: STRING; VAR s: STRING);
VAR
  clas, i, n, key, size, fix, adr, data, len: INTEGER;
  ch: CHAR;
  name: ARRAY [0..32-1] OF CHAR;
  F: TFileStream;
BEGIN

  s := '';

  IF FileExists(filename) THEN BEGIN
    F:= TFileStream.Create(filename,fmOpenRead);
    F.Seek(0,soBeginning);
    ReadString(F, name);
    s := s + #13#10; s := s + name;
    F.Read(key,4);
    s := s + ' '+IntToHex(key,8);
    Read(F, clas);
    s := s + ' '+IntToStr(clas); (*version*)
    F.Read(size,4);
    s := s + ' '+IntToStr(size); s := s + #13#10;
    s := s + 'imports:'; s := s + #13#10;
    ReadString(F, name);

    WHILE name[0] <> #0 DO BEGIN
      s := s + '.'; s := s + name;
      F.Read(key,4); s := s + ' '+IntToHex(key,8); s := s + #13#10;
      ReadString(F, name);
    END;

    s := s + 'type descriptors'; s := s + #13#10;

    F.Read(n,4);
    n := _DIV(n,4);
    i := 0;
    WHILE i < n DO BEGIN
      F.Read(data,4);
      s := s + ' '+IntToHex(data,8);
      INC(i);
    END;
    s := s + #13#10;

    s := s + 'data';
    F.Read(data,4); s := s + ' '+IntToStr(data); s := s + #13#10;
    s := s + 'strings'; s := s + #13#10;
    F.Read(n,4);
    i := 0;
    WHILE i < n DO BEGIN
      F.Read(ch,1);
      s := s + ch;
      INC(i);
    END;
    s := s + #13#10;

    s := s + 'code'; s := s + #13#10;
    F.Read(n,4);
    i := 0;
    WHILE i < n DO BEGIN
      F.Read(data,4);
      s := s + ' '+IntToStr(i);
      s := s + Space(4-length(IntToStr(i)));
      s := s + ' '; s := s + ' ' + IntToHex(data,8);
      s := s + ' ';
      Opcode(data,s);
      s := s + #13#10;
      INC(i);
    END;
    s := s + #13#10;

    s := s + 'commands:'; s := s + #13#10;
    ReadString(F, name);
    WHILE name[0] <> #0 DO BEGIN
      s := s + ' '; s := s + name;
      F.Read(adr,4); s := s + ' '+IntToStr(adr); s := s + #13#10;
      ReadString(F, name);
    END ;
    s := s + #13#10;

    s := s + 'entries'; s := s + #13#10;
    F.Read(n,4);
    i := 0;
    WHILE i < n DO BEGIN
      F.Read(adr,4); s := s + ' '+IntToStr(adr);
      INC(i)
    END ;
    s := s + #13#10;

    s := s + 'pointer refs'; s := s + #13#10;
    F.Read(adr,4);
    WHILE adr <> -1 DO BEGIN
      s := s + ' '+IntToStr(adr);
      F.Read(adr,4)
    END;
    s := s + #13#10;

    F.Read(data,4); s := s + 'fixP = ';  s := s + IntToStr(data); s := s + #13#10;
    F.Read(data,4); s := s + 'fixD = ';  s := s + IntToStr(data); s := s + #13#10;
    F.Read(data,4); s := s + 'fixT = ';  s := s + IntToStr(data); s := s + #13#10;
    F.Read(data,4); s := s + 'entry = '; s := s + IntToStr(data); s := s + #13#10;
    F.Read(ch,1);
    IF ch <> 'O' THEN BEGIN
      s := s + 'format eror'; s := s + #13#10;
    END;

    F.free;

  END ELSE BEGIN
    s := s + ' not found'; s := s + #13#10;
  END;

END;

(******************************************)
(******************************************)
(******************************************)

BEGIN
  mnemo0[0]  := 'MOV';
  mnemo0[1]  := 'LSL';
  mnemo0[2]  := 'ASR';
  mnemo0[3]  := 'ROR';
  mnemo0[4]  := 'AND';
  mnemo0[5]  := 'ANN';
  mnemo0[6]  := 'IOR';
  mnemo0[7]  := 'XOR';
  mnemo0[8]  := 'ADD';
  mnemo0[9]  := 'SUB';
  mnemo0[10] := 'MUL';
  mnemo0[11] := 'DIV';
  mnemo0[12] := 'FAD';
  mnemo0[13] := 'FSB';
  mnemo0[14] := 'FML';
  mnemo0[15] := 'FDV';

  mnemo1[0]  := 'MI ';
  mnemo1[1]  := 'EQ ';
  mnemo1[2]  := 'LS ';
  mnemo1[5]  := 'LT ';
  mnemo1[6]  := 'LE ';
  mnemo1[8]  := 'PL ';
  mnemo1[9]  := 'NE ';
  mnemo1[10] := 'HI ';
  mnemo1[13] := 'GE ';
  mnemo1[14] := 'GT ';
  mnemo1[15] := 'NO ';
END.

