UNIT Func;

{$mode objfpc}{$H+}

INTERFACE

USES
  Base, Scan, Gen;

  PROCEDURE StandFunc(VAR x: Base.Item; fct: LONGINT; restyp: Base.Type_);
  PROCEDURE StandProc(pno: LONGINT);

IMPLEMENTATION

USES
  Expr;

PROCEDURE StandFunc(VAR x: Base.Item; fct: LONGINT; restyp: Base.Type_);
VAR
  y: Base.Item;
  n, npar: LONGINT;
BEGIN

  Expr.Check(Scan.lx_lparen, 'no (');

  npar := _MOD(fct,10);
  fct  := _DIV(fct,10);
  Expr.Expression(x);
  n := 1;

  WHILE sym = Scan.lx_comma DO BEGIN
    Scan.Get(sym);
    Expr.Expression(y);
    INC(n)
  END;

  Expr.Check(Scan.lx_rparen, 'no )');

  IF n = npar THEN BEGIN

    IF fct = 0          THEN BEGIN(*ABS*)
      IF x.typ.form IN [Base.fInt, Base.fReal] THEN BEGIN
        Gen.fAbs(x);
        restyp := x.typ
      END ELSE
        Base.Mark('bad type');
    END ELSE IF fct = 1 THEN BEGIN (*ODD*)
      Expr.CheckInt(x);
      Gen.fOdd(x);
    END ELSE IF fct = 2 THEN BEGIN (*FLOOR*)
      Expr.CheckReal(x);
      Gen.fFloor(x)
    END ELSE IF fct = 3 THEN BEGIN (*FLT*)
      Expr.CheckInt(x);
      Gen.fFloat(x)
    END ELSE IF fct = 4 THEN BEGIN (*ORD*)
      IF x.typ.form <= Base.fProc THEN
        Gen.fOrd(x)
      ELSE IF (x.typ.form = Base.fString) AND (x.b = 2) THEN
        Gen.StrToChar(x)
      ELSE
        Base.Mark('bad type');
    END ELSE IF fct = 5 THEN BEGIN (*CHR*)
      Expr.CheckInt(x);
      Gen.fOrd(x)
    END ELSE IF fct = 6 THEN BEGIN (*LEN*)
        IF x.typ.form = Base.fArray THEN
          Gen.fLen(x)
        ELSE
          Base.Mark('not an array');
    END ELSE IF fct IN [7, 8, 9] THEN BEGIN(*LSL, ASR, ROR*)
      Expr.CheckInt(y);
      IF x.typ.form IN [Base.fInt, Base.fSet] THEN BEGIN
        Gen.fShift(fct-7, x, y);
        restyp := x.typ
      END ELSE
        Base.Mark('bad type')
    END ELSE IF fct = 11 THEN (*ADC*)
      Gen.fADC(x, y)
    ELSE IF fct = 12 THEN (*SBC*)
      Gen.fSBC(x, y)
    ELSE IF fct = 13 THEN (*UML*)
      Gen.fUML(x, y)
    ELSE IF fct = 14 THEN BEGIN (*BIT*)
      Expr.CheckInt(x);
      Expr.CheckInt(y);
      Gen.fBit(x, y)
    END ELSE IF fct = 15 THEN BEGIN (*REG*)
      Expr.CheckConst(x);
      Expr.CheckInt(x);
      Gen.fRegister(x)
    END ELSE IF fct = 16 THEN BEGIN (*VAL*)
      IF (x.mode= Base.cTyp) AND (x.typ.size <= y.typ.size) THEN BEGIN
        restyp := x.typ;
        x := y
      END ELSE
        Base.Mark('casting not allowed');
    END ELSE IF fct = 17 THEN (*ADR*)
      Gen.fAdr(x)
    ELSE IF fct = 18 THEN BEGIN (*SIZE*)
      IF x.mode = Base.cTyp THEN
        Base.MakeConstItem(x, Base.intType, x.typ.size)
      ELSE
        Base.Mark('must be a type');
    END ELSE IF fct = 19 THEN BEGIN (*COND*)
      Expr.CheckConst(x);
      Expr.CheckInt(x);
      Gen.fCondition(x)
    END ELSE IF fct = 20 THEN BEGIN (*H*)
      Expr.CheckConst(x);
      Expr.CheckInt(x);
      Gen.fH(x)
    END;
    x.typ := restyp;
  END ELSE
    Base.Mark('wrong nof params');
END;

PROCEDURE StandProc(pno: LONGINT);
VAR
  nap, npar: LONGINT;
  x, y, z: Base.Item;
BEGIN
  Expr.Check(Scan.lx_lparen, 'no (');

  npar := _MOD(pno,10);
  pno  := _DIV(pno,10);
  Expr.Expression(x);
  nap := 1;

  IF sym = Scan.lx_comma THEN BEGIN
    Scan.Get(sym);
    Expr.Expression(y);
    nap := 2;
    z.typ := Base.noType;
    WHILE sym = Scan.lx_comma DO BEGIN
      Scan.Get(sym);
      Expr.Expression(z);
      INC(nap)
    END;
  END ELSE
    y.typ := Base.noType;

  Check(Scan.lx_rparen, 'no )');

  IF (npar = nap) OR (pno IN [0, 1]) THEN BEGIN
    IF pno IN [0, 1] THEN BEGIN(*INC, DEC*)
      CheckInt(x);
      CheckReadOnly(x);
      IF y.typ <> Base.noType THEN CheckInt(y);
      Gen.fIncrement(pno, x, y)
    END ELSE IF pno IN [2, 3] THEN BEGIN (*INCL, EXCL*)
      Expr.CheckSet(x);
      Expr.CheckReadOnly(x);
      Expr.CheckInt(y);
      Gen.fInclude(pno-2, x, y)
    END ELSE IF pno = 4 THEN BEGIN
      CheckBool(x);
      Gen.fAssert(x)
    END ELSE IF pno = 5 THEN BEGIN (*NEW*)
      Expr.CheckReadOnly(x);
      IF (x.typ.form = Base.fPointer) AND (x.typ.base.form = Base.fRecord) THEN
        Gen.fNew(x)
      ELSE
        Base.Mark('not a pointer to record');
    END ELSE IF pno = 6 THEN BEGIN
      Expr.CheckReal(x);
      Expr.CheckInt(y);
      Expr.CheckReadOnly(x);
      Gen.fPack(x, y)
    END ELSE IF pno = 7 THEN BEGIN
      Expr.CheckReal(x);
      Expr.CheckInt(y);
      Expr.CheckReadOnly(x);
      Gen.fUnpk(x, y)
    END ELSE IF pno = 8 THEN BEGIN
      IF x.typ.form <= Base.fSet THEN
        Gen.fLed(x)
      ELSE
        Base.Mark('bad type');
    END ELSE IF pno = 10 THEN BEGIN
      Expr.CheckInt(x);
      Gen.fGet(x, y)
    END ELSE IF pno = 11 THEN BEGIN
      Expr.CheckInt(x);
      Gen.fPut(x, y)
    END ELSE IF pno = 12 THEN BEGIN
      Expr.CheckInt(x);
      Expr.CheckInt(y);
      Expr.CheckInt(z);
      Gen.fCopy(x, y, z)
    END ELSE IF pno = 13 THEN BEGIN
      Expr.CheckConst(x);
      Expr.CheckInt(x);
      Gen.fLDPSR(x)
    END ELSE IF pno = 14 THEN BEGIN
      Expr.CheckInt(x);
      Gen.fLDREG(x, y)
    END;
  END ELSE
    Base.Mark('wrong nof parameters');
END;

END.

