UNIT Gen;

{$mode objfpc}{$H+}

INTERFACE

USES
  Classes, Base, Scan, Files;

VAR
  pc: LONGINT;

  PROCEDURE Open(v: INTEGER);
  PROCEDURE SetDataSize(dc: LONGINT);
  PROCEDURE Header;
  PROCEDURE Close(AName: Base.TStrings; VAR modid: Base.TIdent; key, nofent: LONGINT);
  PROCEDURE BuildTD(T: Base.Type_; VAR dc: LONGINT);
  FUNCTION  Here(): LONGINT;
  PROCEDURE FJump(VAR L: LONGINT);
  PROCEDURE FixLink(L: LONGINT);
  PROCEDURE StrToChar(VAR x: Base.Item);
  PROCEDURE Enter(parblksize, locblksize: LONGINT; int: BOOLEAN);
  PROCEDURE Return(form: INTEGER; VAR x: Base.Item; size: LONGINT; int: BOOLEAN);
  PROCEDURE CFJump(VAR x: Base.Item);
  PROCEDURE BJump(L: LONGINT);
  PROCEDURE CBJump(VAR x: Base.Item; L: LONGINT);
  PROCEDURE Fixup(VAR x: Base.Item);
  PROCEDURE TypeTest(VAR x: Base.Item; T: Base.Type_; varpar, isguard: BOOLEAN);
  PROCEDURE CopyString(VAR x, y: Base.Item);
  PROCEDURE StoreStruct(VAR x, y: Base.Item);
  PROCEDURE Store(VAR x, y: Base.Item);
  PROCEDURE Field(VAR x: Base.Item; y: Base.Object_);
  PROCEDURE Index(VAR x, y: Base.Item);
  PROCEDURE DeRef(VAR x: Base.Item);
  PROCEDURE Call(VAR x: Base.Item; r: LONGINT);
  PROCEDURE PrepCall(VAR x: Base.Item; VAR r: LONGINT);
  PROCEDURE For2(VAR x, y, w: Base.Item);
  PROCEDURE For1(VAR x, y, z, w: Base.Item; VAR L: LONGINT);
  PROCEDURE For0(VAR x, y: Base.Item);
  PROCEDURE CheckRegs;
  PROCEDURE StringParam(VAR x: Base.Item);
  PROCEDURE ValueParam(VAR x: Base.Item);
  PROCEDURE VarParam(VAR x: Base.Item; ftype: Base.Type_);
  PROCEDURE OpenArrayParam(VAR x: Base.Item);

  PROCEDURE Not1(VAR x: Base.Item);
  PROCEDURE And1(VAR x: Base.Item);
  PROCEDURE And2(VAR x, y: Base.Item);
  PROCEDURE Or1(VAR x: Base.Item);
  PROCEDURE Or2(VAR x, y: Base.Item);
  PROCEDURE Neg(VAR x: Base.Item);
  PROCEDURE AddOp(op: LONGINT; VAR x, y: Base.Item);
  PROCEDURE MulOp(VAR x, y: Base.Item);
  PROCEDURE DivOp(op: LONGINT; VAR x, y: Base.Item);
  PROCEDURE RealOp(op: INTEGER; VAR x, y: Base.Item);
  PROCEDURE Singleton(VAR x: Base.Item);
  PROCEDURE Set2(VAR x, y: Base.Item);
  PROCEDURE In2(VAR x, y: Base.Item);
  PROCEDURE SetOp(op: LONGINT; VAR x, y: Base.Item);

  PROCEDURE StringRelation(op: INTEGER; VAR x, y: Base.Item);
  PROCEDURE RealRelation(op: INTEGER; VAR x, y: Base.Item);
  PROCEDURE IntRelation(op: INTEGER; VAR x, y: Base.Item);

  PROCEDURE MakeStringItem(VAR x: Base.Item; len: LONGINT);

  PROCEDURE fIncrement(upordown: LONGINT; VAR x, y: Base.Item);
  PROCEDURE fInclude(inorex: LONGINT; VAR x, y: Base.Item);
  PROCEDURE fAssert(VAR x: Base.Item);
  PROCEDURE fNew(VAR x: Base.Item);
  PROCEDURE fPack(VAR x, y: Base.Item);
  PROCEDURE fUnpk(VAR x, y: Base.Item);
  PROCEDURE fLed(VAR x: Base.Item);
  PROCEDURE fGet(VAR x, y: Base.Item);
  PROCEDURE fPut(VAR x, y: Base.Item);
  PROCEDURE fCopy(VAR x, y, z: Base.Item);
  PROCEDURE fLDPSR(VAR x: Base.Item);
  PROCEDURE fLDREG(VAR x, y: Base.Item);
  PROCEDURE fAbs(VAR x: Base.Item);
  PROCEDURE fOdd(VAR x: Base.Item);
  PROCEDURE fFloor(VAR x: Base.Item);
  PROCEDURE fFloat(VAR x: Base.Item);
  PROCEDURE fOrd(VAR x: Base.Item);
  PROCEDURE fLen(VAR x: Base.Item);
  PROCEDURE fShift(fct: LONGINT; VAR x, y: Base.Item);
  PROCEDURE fADC(VAR x, y: Base.Item);
  PROCEDURE fSBC(VAR x, y: Base.Item);
  PROCEDURE fUML(VAR x, y: Base.Item);
  PROCEDURE fBit(VAR x, y: Base.Item);
  PROCEDURE fRegister(VAR x: Base.Item);
  PROCEDURE fH(VAR x: Base.Item);
  PROCEDURE fAdr(VAR x: Base.Item);
  PROCEDURE fCondition(VAR x: Base.Item);

IMPLEMENTATION

CONST
  maxCode = 8000;
  maxStrx = 2400;
  maxTD   = 120;

  StkOrg0 = -64;
  VarOrg0 = 0;
  U   = $2000;
  V   = $1000;
  MT  = 12;
  SB  = 13;
  SP  = 14;
  LNK = 15;
  C24 = $1000000;
  Reg = 10;
  RegI = 11;
  mCond = 12;

  opMov = 0;  opLsl = 1;  opAsr = 2;  opRor = 3;
  opAnd = 4;  opAnn = 5;  opIor = 6;  opXor = 7;
  opAdd = 8;  opSub = 9;  opCmp = 9;  opMul = 10;
  opDiv = 11; opFad = 12; opFsb = 13; opFml = 14;
  opFdv = 15; opLdr = 8;  opStr = 10;
  opBR  = 0;  opBLR = 1;  opBC  = 2;  opBL  = 3;
  opMI  = 0;  opPL  = 8;  opEQ  = 1;  opNE  = 9;
  opLT  = 5;  opGE  = 13; opLE  = 6;  opGT  = 14;

VAR
  varsize: LONGINT;
  tdx, strx: LONGINT;
  RH: LONGINT;
  curSB: LONGINT;
  frame: LONGINT;
  fixorgP, fixorgD, fixorgT: LONGINT;
  check: BOOLEAN;
  version: INTEGER;
  entry: LONGINT;

  relmap: ARRAY [0..6-1] OF INTEGER;
  code  : ARRAY [0..maxCode-1] OF LONGINT;
  data  : ARRAY [0..maxTD-1] OF LONGINT;
  str   : ARRAY [0..maxStrx-1] OF CHAR;

PROCEDURE Put0(op, a, b, c: LONGINT);
BEGIN
  code[pc] := ((a*$10 + b) * $10 + op) * $10000 + c;
  INC(pc);
END;

PROCEDURE Put1(op, a, b, im: LONGINT);
BEGIN
  IF im < 0 THEN INC(op, V);
  code[pc] := (((a+$40) * $10 + b) * $10 + op) * $10000 + _MOD(im,$10000);
  INC(pc);
END;

PROCEDURE Put1a(op, a, b, im: LONGINT);
BEGIN
  IF (im >= -$10000) AND (im <= $0FFFF) THEN
    Put1(op, a, b, im)
  ELSE BEGIN
    Put1(opMov+U, RH, 0, _DIV(im,$10000));
    IF _MOD(im,$10000) <> 0 THEN Put1(opIor, RH, RH, _MOD(im,$10000));
    Put0(op, a, b, RH)
  END
END;

PROCEDURE Put2(op, a, b, off: LONGINT);
BEGIN
  code[pc] := ((op * $10 + a) * $10 + b) * $100000 + _MOD(off,$100000);
  INC(pc);
END;

PROCEDURE Put3(op, cond, off: LONGINT);
BEGIN
  code[pc] := ((op+12) * $10 + cond) * $1000000 + _MOD(off,$1000000);
  INC(pc);
END;

PROCEDURE incR;
BEGIN
  IF RH < MT-1 THEN
    INC(RH)
  ELSE
    Base.Mark('register stack overflow');
END;

PROCEDURE setCC(VAR x: Base.Item; n: LONGINT);
BEGIN
  x.mode := mCond;
  x.a := 0;
  x.b := 0;
  x.r := n;
END;

PROCEDURE getSB(abase: LONGINT);
BEGIN
  IF (version <> 0) AND ((abase <> curSB) OR (abase <> 0)) THEN BEGIN
    Put2(opLdr, SB, -abase, pc-fixorgD);
    fixorgD := pc-1;
    curSB := abase;
  END;
END;

FUNCTION negated(cond: LONGINT): LONGINT;
BEGIN
  IF cond < 8 THEN cond := cond+8 ELSE cond := cond-8;
  RESULT := cond;
END;

FUNCTION merged(L0, L1: LONGINT): LONGINT;
VAR
  L2, L3: LONGINT;
BEGIN
  IF L0 <> 0 THEN BEGIN
    L3 := L0;
    REPEAT
      L2 := L3;
      L3 := _MOD(code[L2],$40000)
    UNTIL L3 = 0;
    code[L2] := code[L2] + L1;
    L1 := L0;
  END;
  RESULT := L1;
END;

PROCEDURE fix(at, w: LONGINT);
BEGIN
  code[at] := _DIV(code[at],C24) * C24 + _MOD(w,C24)
END;

PROCEDURE Trap(cond, num: LONGINT);
BEGIN
  Put3(opBLR, cond, (Base.filepos-1)*$100 + num*$10 + MT);
END;

PROCEDURE CheckRegs;
BEGIN
  IF RH <> 0 THEN BEGIN
    Base.Mark('Reg Stack');
    RH := 0;
  END;
  IF pc >= maxCode - 40 THEN Base.Mark('program too long');
END;

PROCEDURE NilCheck;
BEGIN
  IF check THEN Trap(opEQ, 4);
END;

PROCEDURE invalSB;
BEGIN
  curSB := 1
END;

FUNCTION Here(): LONGINT;
BEGIN
  invalSB;
  RESULT := pc;
END;

PROCEDURE FixLink(L: LONGINT);
VAR
  L1: LONGINT;
BEGIN
  invalSB;
  WHILE L <> 0 DO BEGIN
    L1 := _MOD(code[L],$40000);
    fix(L, pc-L-1);
    L := L1;
  END;
END;

PROCEDURE FixLinkWith(L0, dst: LONGINT);
VAR
  L1: LONGINT;
BEGIN
  WHILE L0 <> 0 DO BEGIN
    L1 := _MOD(code[L0],C24);
    code[L0] := _DIV(code[L0],C24) * C24 + _MOD(dst - L0 - 1,C24);
    L0 := L1
  END;
END;

PROCEDURE Fixup(VAR x: Base.Item);
BEGIN
  FixLink(x.a)
END;

PROCEDURE Load(VAR x: Base.Item);
VAR
  op: LONGINT;
BEGIN

  IF x.typ.size = 1 THEN
    op := opLdr+1
  ELSE
    op := opLdr;

  IF x.mode <> Reg THEN BEGIN
    IF x.mode = Base.cConst THEN BEGIN
      IF x.typ.form = Base.fProc THEN BEGIN
        IF x.r > 0 THEN
          Base.Mark('not allowed')
        ELSE IF x.r = 0 THEN BEGIN
          Put3(opBL, 7, 0);
          Put1a(opSub, RH, LNK, pc*4 - x.a)
        END ELSE BEGIN
          GetSB(x.r);
          Put1(opAdd, RH, SB, x.a + $100);
        END;
      END ELSE IF (x.a <= $0FFFF) AND (x.a >= -$10000) THEN
        Put1(opMov, RH, 0, x.a)
      ELSE BEGIN
        Put1(opMov+U, RH, 0, _MOD(_DIV(x.a,$10000),$10000));
        IF _MOD(x.a,$10000) <> 0 THEN Put1(opIor, RH, RH, _MOD(x.a,$10000));
      END ;
      x.r := RH;
      incR;
    END ELSE IF x.mode = Base.cVar THEN BEGIN
      IF x.r > 0 THEN
        Put2(op, RH, SP, x.a + frame)
      ELSE BEGIN
        GetSB(x.r);
        Put2(op, RH, SB, x.a);
      END ;
      x.r := RH;
      incR;
    END ELSE IF x.mode = Base.cPar THEN BEGIN
      Put2(opLdr, RH, SP, x.a + frame);
      Put2(op, RH, RH, x.b);
      x.r := RH;
      incR;
    END ELSE IF x.mode = RegI THEN
      Put2(op, x.r, x.r, x.a)
    ELSE IF x.mode = mCond THEN BEGIN
      Put3(opBC, negated(x.r), 2);
      FixLink(x.b);
      Put1(opMov, RH, 0, 1);
      Put3(opBC, 7, 1);
      FixLink(x.a);
      Put1(opMov, RH, 0, 0);
      x.r := RH;
      incR;
    END ;
    x.mode := Reg;
  END;
END;

PROCEDURE LoadAdr(VAR x: Base.Item);
BEGIN
  IF x.mode = Base.cVar THEN BEGIN
    IF x.r > 0 THEN
      Put1a(opAdd, RH, SP, x.a + frame)
    ELSE BEGIN
      GetSB(x.r);
      Put1a(opAdd, RH, SB, x.a)
    END;
    x.r := RH;
    incR;
  END ELSE IF x.mode = Base.cPar THEN BEGIN
    Put2(opLdr, RH, SP, x.a + frame);
    IF x.b <> 0 THEN Put1a(opAdd, RH, RH, x.b);
    x.r := RH;
    incR;
  END ELSE IF x.mode = RegI THEN BEGIN
    IF x.a <> 0 THEN Put1a(opAdd, x.r, x.r, x.a);
  END ELSE
    Base.Mark('address error');
  x.mode := Reg;
END;

PROCEDURE LoadCond(VAR x: Base.Item);
BEGIN
  IF x.typ.form = Base.fBool THEN BEGIN
    IF x.mode = Base.cConst THEN
      x.r := 15 - x.a*8
    ELSE BEGIN
      Load(x);
      IF _DIV(code[pc-1],$40000000) <> -2 THEN Put1(opCmp, x.r, x.r, 0);
      x.r := opNE;
      DEC(RH)
    END;
    x.mode := mCond;
    x.a := 0;
    x.b := 0;
  END ELSE
    Base.Mark('not Boolean?');
END;

PROCEDURE LoadTypTagAdr(T: Base.Type_);
VAR
  x: Base.Item;
BEGIN
  x.mode := Base.cVar;
  x.a := T.len;
  x.r := -T.mno;
  loadAdr(x)
END;

PROCEDURE LoadStringAdr(VAR x: Base.Item);
BEGIN
  GetSB(0);
  Put1a(opAdd, RH, SB, varsize+x.a);
  x.mode := Reg;
  x.r := RH;
  incR;
END;

(**********)
(**********)
(**********)
(**********)
(**********)


PROCEDURE Not1(VAR x: Base.Item);
VAR
  t: LONGINT;
BEGIN
  IF x.mode <> mCond THEN LoadCond(x);
  x.r := negated(x.r);
  t := x.a;
  x.a := x.b;
  x.b := t;
END;

PROCEDURE And1(VAR x: Base.Item);
BEGIN
  IF x.mode <> mCond THEN LoadCond(x);
  Put3(opBC, negated(x.r), x.a);
  x.a := pc-1;
  FixLink(x.b);
  x.b := 0;
END;

PROCEDURE And2(VAR x, y: Base.Item);
BEGIN
  IF y.mode <> mCond THEN LoadCond(y);
  x.a := merged(y.a, x.a);
  x.b := y.b;
  x.r := y.r;
END;

PROCEDURE Or1(VAR x: Base.Item);
BEGIN
  IF x.mode <> mCond THEN LoadCond(x);
  Put3(opBC, x.r, x.b);
  x.b := pc-1;
  FixLink(x.a);
  x.a := 0;
END;

PROCEDURE Or2(VAR x, y: Base.Item);
BEGIN
  IF y.mode <> mCond THEN LoadCond(y);
  x.a := y.a;
  x.b := merged(y.b, x.b);
  x.r := y.r;
END;

PROCEDURE Neg(VAR x: Base.Item);
BEGIN
  IF x.typ.form = Base.fInt THEN BEGIN
    IF x.mode = Base.cConst THEN
      x.a := -x.a
    ELSE BEGIN
      Load(x);
      Put1(opMov, RH, 0, 0);
      Put0(opSub, x.r, RH, x.r)
    END
  END ELSE IF x.typ.form = Base.fReal THEN BEGIN
    IF x.mode = Base.cConst THEN
      x.a := x.a + $7FFFFFFF + 1
    ELSE BEGIN
      Load(x);
      Put1(opMov, RH, 0, 0);
      Put0(opFsb, x.r, RH, x.r);
    END
  END ELSE BEGIN
    IF x.mode = Base.cConst THEN
      x.a := -x.a-1
    ELSE BEGIN
      Load(x);
      Put1(opXor, x.r, x.r, -1);
    END;
  END;
END;

PROCEDURE AddOp(op: LONGINT; VAR x, y: Base.Item);
BEGIN
  IF op = Scan.lx_plus THEN BEGIN
    IF (x.mode = Base.cConst) AND (y.mode = Base.cConst) THEN
      x.a := x.a + y.a
    ELSE IF y.mode = Base.cConst THEN BEGIN
      Load(x);
      IF y.a <> 0 THEN Put1a(opAdd, x.r, x.r, y.a);
    END ELSE BEGIN
      Load(x);
      Load(y);
      Put0(opAdd, RH-2, x.r, y.r);
      DEC(RH);
      x.r := RH-1;
    END;
  END ELSE BEGIN
    IF (x.mode = Base.cConst) AND (y.mode = Base.cConst) THEN
      x.a := x.a - y.a
    ELSE IF y.mode = Base.cConst THEN BEGIN
      Load(x);
      IF y.a <> 0 THEN Put1a(opSub, x.r, x.r, y.a);
    END ELSE BEGIN
      Load(x);
      Load(y);
      Put0(opSub, RH-2, x.r, y.r);
      DEC(RH);
      x.r := RH-1;
    END;
  END;
END;

FUNCTION log2(m: LONGINT; VAR e: LONGINT): LONGINT;
BEGIN
  e := 0;
  WHILE NOT ODD(m) DO BEGIN
    m := _DIV(m,2);
    INC(e);
  END;
  RESULT := m;
END;

PROCEDURE MulOp(VAR x, y: Base.Item);
VAR
  e: LONGINT;
BEGIN
  IF (x.mode = Base.cConst) AND (y.mode = Base.cConst) THEN
    x.a := x.a * y.a
  ELSE IF (y.mode = Base.cConst) AND (y.a >= 2) AND (log2(y.a, e) = 1) THEN BEGIN
    Load(x);
    Put1(opLsl, x.r, x.r, e)
  END ELSE IF y.mode = Base.cConst THEN BEGIN
    Load(x);
    Put1a(opMul, x.r, x.r, y.a)
  END ELSE IF (x.mode = Base.cConst) AND (x.a >= 2) AND (log2(x.a, e) = 1) THEN BEGIN
    Load(y);
    Put1(opLsl, y.r, y.r, e);
    x.mode := Reg;
    x.r := y.r;
  END ELSE IF x.mode = Base.cConst THEN BEGIN
    Load(y);
    Put1a(opMul, y.r, y.r, x.a);
    x.mode := Reg;
    x.r := y.r
  END ELSE BEGIN
    Load(x);
    Load(y);
    Put0(opMul, RH-2, x.r, y.r);
    DEC(RH);
    x.r := RH-1;
  END;
END;

PROCEDURE DivOp(op: LONGINT; VAR x, y: Base.Item);
VAR
  e: LONGINT;
BEGIN
  IF op = Scan.lx_div THEN BEGIN
    IF (x.mode = Base.cConst) AND (y.mode = Base.cConst) THEN BEGIN
      IF y.a > 0 THEN
        x.a := _DIV(x.a,y.a)
      ELSE
        Base.Mark('bad divisor');
    END ELSE IF (y.mode = Base.cConst) AND (y.a >= 2) AND (log2(y.a, e) = 1) THEN BEGIN
      Load(x);
      Put1(opAsr, x.r, x.r, e)
    END ELSE IF y.mode = Base.cConst THEN BEGIN
      IF y.a > 0 THEN BEGIN
        Load(x);
        Put1a(opDiv, x.r, x.r, y.a)
      END ELSE
        Base.Mark('bad divisor');
    END ELSE BEGIN
      Load(y);
      IF check THEN Trap(opLE, 6);
      Load(x);
      Put0(opDiv, RH-2, x.r, y.r);
      DEC(RH);
      x.r := RH-1;
    END;
  END ELSE BEGIN
    IF (x.mode = Base.cConst) AND (y.mode = Base.cConst) THEN BEGIN
      IF y.a > 0 THEN
        x.a := _MOD(x.a,y.a)
      ELSE
        Base.Mark('bad modulus');
    END ELSE IF (y.mode = Base.cConst) AND (y.a >= 2) AND (log2(y.a, e) = 1) THEN BEGIN
      Load(x);
      IF e <= 16 THEN
        Put1(opAnd, x.r, x.r, y.a-1)
      ELSE BEGIN
        Put1(opLsl, x.r, x.r, 32-e);
        Put1(opRor, x.r, x.r, 32-e);
      END;
    END ELSE IF y.mode = Base.cConst THEN BEGIN
      IF y.a > 0 THEN BEGIN
        Load(x);
        Put1a(opDiv, x.r, x.r, y.a);
        Put0(opMov+U, x.r, 0, 0);
      END ELSE
        Base.Mark('bad modulus');
    END ELSE BEGIN
      Load(y);
      IF check THEN Trap(opLE, 6);
      Load(x);
      Put0(opDiv, RH-2, x.r, y.r);
      Put0(opMov+U, RH-2, 0, 0);
      DEC(RH);
      x.r := RH-1;
    END;
  END;
END;

PROCEDURE RealOp(op: INTEGER; VAR x, y: Base.Item);
BEGIN
  Load(x);
  Load(y);
  IF      op = Scan.lx_plus  THEN Put0(opFad, RH-2, x.r, y.r)
  ELSE IF op = Scan.lx_minus THEN Put0(opFsb, RH-2, x.r, y.r)
  ELSE IF op = Scan.lx_times THEN Put0(opFml, RH-2, x.r, y.r)
  ELSE IF op = Scan.lx_rdiv  THEN Put0(opFdv, RH-2, x.r, y.r);
  DEC(RH);
  x.r := RH-1;
END;

PROCEDURE Singleton(VAR x: Base.Item);
BEGIN
  IF x.mode = Base.cConst THEN
    x.a := LSL(1, x.a)
  ELSE BEGIN
    Load(x);
    Put1(opMov, RH, 0, 1);
    Put0(opLsl, x.r, RH,  x.r)
  END;
END;

PROCEDURE Set2(VAR x, y: Base.Item);
BEGIN
  IF (x.mode = Base.cConst) AND ( y.mode = Base.cConst) THEN BEGIN
    IF x.a <= y.a THEN
      x.a := LSL(2, y.a) - LSL(1, x.a)
    ELSE
      x.a := 0;
  END ELSE BEGIN
    IF (x.mode = Base.cConst) AND (x.a <= 16) THEN
      x.a := LSL(-1, x.a)
    ELSE BEGIN
      Load(x);
      Put1(opMov, RH, 0, -1);
      Put0(opLsl, x.r, RH, x.r)
    END;
    IF (y.mode = Base.cConst) AND (y.a < 16) THEN BEGIN
      Put1(opMov, RH, 0, LSL(-2, y.a));
      y.mode := Reg;
      y.r := RH;
      incR;
    END ELSE BEGIN
      Load(y);
      Put1(opMov, RH, 0, -2);
      Put0(opLsl, y.r, RH, y.r)
    END;
    IF x.mode = Base.cConst THEN BEGIN
      IF x.a <> 0 THEN BEGIN
        Put1(opXor, y.r, y.r, -1);
        Put1a(opAnd, RH-1, y.r, x.a)
      END;
      x.mode := Reg;
      x.r := RH-1
    END ELSE BEGIN
      DEC(RH);
      Put0(opAnn, RH-1, x.r, y.r)
    END;
  END;
END;

PROCEDURE In2(VAR x, y: Base.Item);
BEGIN
  Load(y);
  IF x.mode = Base.cConst THEN BEGIN
    Put1(opRor, y.r, y.r, _MOD(x.a + 1,$20));
    DEC(RH);
  END ELSE BEGIN
    Load(x);
    Put1(opAdd, x.r, x.r, 1);
    Put0(opRor, y.r, y.r, x.r);
    DEC(RH, 2);
  END;
  SetCC(x, opMI);
END;

PROCEDURE SetOp(op: LONGINT; VAR x, y: Base.Item);
VAR
  xset, yset: INTEGER;
BEGIN
  IF (x.mode = Base.cConst) AND (y.mode = Base.cConst) THEN BEGIN
    xset := x.a;
    yset := y.a;
    IF      op = Scan.lx_plus  THEN xset := xset OR yset
    ELSE IF op = Scan.lx_minus THEN xset := xset AND NOT yset
    ELSE IF op = Scan.lx_times THEN xset := xset AND yset
    ELSE IF op = Scan.lx_rdiv  THEN xset := xset XOR yset;
    x.a := xset;
  END ELSE IF y.mode = Base.cConst THEN BEGIN
    Load(x);
    IF      op = Scan.lx_plus  THEN Put1a(opIor, x.r, x.r, y.a)
    ELSE IF op = Scan.lx_minus THEN Put1a(opAnn, x.r, x.r, y.a)
    ELSE IF op = Scan.lx_times THEN Put1a(opAnd, x.r, x.r, y.a)
    ELSE IF op = Scan.lx_rdiv  THEN Put1a(opXor, x.r, x.r, y.a);
  END ELSE BEGIN
    Load(x);
    Load(y);
    IF      op = Scan.lx_plus  THEN Put0(opIor, RH-2, x.r, y.r)
    ELSE IF op = Scan.lx_minus THEN Put0(opAnn, RH-2, x.r, y.r)
    ELSE IF op = Scan.lx_times THEN Put0(opAnd, RH-2, x.r, y.r)
    ELSE IF op = Scan.lx_rdiv  THEN Put0(opXor, RH-2, x.r, y.r);
    DEC(RH);
    x.r := RH-1;
  END
END;

PROCEDURE IntRelation(op: INTEGER; VAR x, y: Base.Item);
BEGIN
  IF (y.mode = Base.cConst) AND (y.typ.form <> Base.fProc) THEN BEGIN
    Load(x);
    IF (y.a <> 0) OR NOT (op IN [Scan.lx_eql, Scan.lx_neq]) OR (_DIV(code[pc-1],$40000000) <> -2) THEN
      Put1a(opCmp, x.r, x.r, y.a);
    DEC(RH);
  END ELSE BEGIN
    IF (x.mode = mCond) OR (y.mode = mCond) THEN Base.Mark('not implemented');
    Load(x);
    Load(y);
    Put0(opCmp, x.r, x.r, y.r);
    DEC(RH, 2);
  END ;
  SetCC(x, relmap[op - Scan.lx_eql]);
END;

PROCEDURE RealRelation(op: INTEGER; VAR x, y: Base.Item);
BEGIN
  Load(x);
  IF (y.mode = Base.cConst) AND (y.a = 0) THEN
    DEC(RH)
  ELSE BEGIN
    Load(y);
    Put0(opFsb, x.r, x.r, y.r);
    DEC(RH, 2);
  END;
  SetCC(x, relmap[op - Scan.lx_eql])
END;

PROCEDURE StringRelation(op: INTEGER; VAR x, y: Base.Item);
BEGIN
  IF x.typ.form = Base.fString THEN LoadStringAdr(x) ELSE LoadAdr(x);
  IF y.typ.form = Base.fString THEN LoadStringAdr(y) ELSE LoadAdr(y);
  Put2(opLdr+1, RH, x.r, 0);
  Put1(opAdd, x.r, x.r, 1);
  Put2(opLdr+1, RH+1, y.r, 0);
  Put1(opAdd, y.r, y.r, 1);
  Put0(opCmp, RH+2, RH, RH+1);
  Put3(opBC, opNE, 2);
  Put1(opCmp, RH+2, RH, 0);
  Put3(opBC, opNE, -8);
  DEC(RH, 2);
  SetCC(x, relmap[op - Scan.lx_eql]);
END;

PROCEDURE Field(VAR x: Base.Item; y: Base.Object_);
BEGIN;
  IF x.mode = Base.cVar THEN BEGIN
    IF x.r >= 0 THEN
      x.a := x.a + y.val
    ELSE BEGIN
      LoadAdr(x);
      x.mode := RegI;
      x.a := y.val;
    END;
  END ELSE IF x.mode = RegI THEN
    x.a := x.a + y.val
  ELSE IF x.mode = Base.cPar THEN
    x.b := x.b + y.val;
END;

PROCEDURE Index(VAR x, y: Base.Item);
VAR
  s, lim: LONGINT;
BEGIN

  s := x.typ.base.size;
  lim := x.typ.len;

  IF (y.mode = Base.cConst) AND (lim >= 0) THEN BEGIN

    IF (y.a < 0) OR (y.a >= lim) THEN Base.Mark('bad index');
    IF x.mode IN [Base.cVar, RegI] THEN
      x.a := y.a * s + x.a
    ELSE IF x.mode = Base.cPar THEN
      x.b := y.a * s + x.b;

  END ELSE BEGIN

    Load(y);

    IF check THEN BEGIN
      IF lim >= 0 THEN
        Put1a(opCmp, RH, y.r, lim)
      ELSE BEGIN
        IF x.mode IN [Base.cVar, Base.cPar] THEN BEGIN
          Put2(opLdr, RH, SP, x.a+4+frame);
          Put0(opCmp, RH, y.r, RH)
        END ELSE
          Base.Mark('error in Index');
      END;
      Trap(10, 1);
    END;

    IF s = 4 THEN
      Put1(opLsl, y.r, y.r, 2)
    ELSE IF s > 1 THEN
      Put1a(opMul, y.r, y.r, s);

    IF x.mode = Base.cVar THEN BEGIN
      IF x.r > 0 THEN BEGIN
        Put0(opAdd, y.r, SP, y.r);
        INC(x.a, frame);
      END ELSE BEGIN
        GetSB(x.r);
        IF x.r = 0 THEN
          Put0(opAdd, y.r, SB, y.r)
        ELSE BEGIN
          Put1a(opAdd, RH, SB, x.a);
          Put0(opAdd, y.r, RH, y.r);
          x.a := 0;
        END;
      END;
      x.r := y.r;
      x.mode := RegI;
    END ELSE IF x.mode = Base.cPar THEN BEGIN
      Put2(opLdr, RH, SP, x.a + frame);
      Put0(opAdd, y.r, RH, y.r);
      x.mode := RegI;
      x.r := y.r;
      x.a := x.b;
    END ELSE IF x.mode = RegI THEN BEGIN
      Put0(opAdd, x.r, x.r, y.r);
      DEC(RH);
    END;

  END;

END;

(**********)
(**********)
(**********)
(**********)
(**********)

PROCEDURE OpenArrayParam(VAR x: Base.Item);
BEGIN
  loadAdr(x);
  IF x.typ.len >= 0 THEN
    Put1a(opMov, RH, 0, x.typ.len)
  ELSE
  Put2(opLdr, RH, SP, x.a+4+frame);
  incR;
END;

PROCEDURE VarParam(VAR x: Base.Item; ftype: Base.Type_);
VAR
  xmd: INTEGER;
BEGIN
  xmd := x.mode;
  loadAdr(x);
  IF (ftype.form = Base.fArray) AND (ftype.len < 0) THEN BEGIN
    IF x.typ.len >= 0 THEN
      Put1a(opMov, RH, 0, x.typ.len)
    ELSE
      Put2(opLdr, RH, SP, x.a+4+frame);
    incR;
  END ELSE IF ftype.form = Base.fRecord THEN BEGIN
    IF xmd = Base.cPar THEN BEGIN
      Put2(opLdr, RH, SP, x.a+4+frame);
      incR;
    END ELSE
      loadTypTagAdr(x.typ);
  END;
END;

PROCEDURE ValueParam(VAR x: Base.Item);
BEGIN
  load(x)
END;

PROCEDURE StringParam(VAR x: Base.Item);
BEGIN
  loadStringAdr(x);
  Put1(opMov, RH, 0, x.b);
  incR;
END;

PROCEDURE MakeStringItem(VAR x: Base.Item; len: LONGINT);
VAR
  i: LONGINT;
BEGIN
  x.mode := Base.cConst;
  x.typ := Base.strType;
  x.a := strx;
  x.b := len;
  i := 0;
  IF strx + len + 4 < maxStrx THEN BEGIN
    WHILE len > 0 DO BEGIN
      str[strx] := Scan.str[i];
      INC(strx);
      INC(i);
      DEC(len)
    END;
    WHILE _MOD(strx,4) <> 0 DO BEGIN
      str[strx] := #0;
      INC(strx);
    END;
  END ELSE
    Base.Mark('too many strings');
END;

PROCEDURE StrToChar(VAR x: Base.Item);
BEGIN
  x.typ := Base.charType;
  DEC(strx, 4);
  x.a := ORD(str[x.a]);
END;

(**********)
(**********)
(**********)
(**********)
(**********)

PROCEDURE FJump(VAR L: LONGINT);
BEGIN
  Put3(opBC, 7, L);
  L := pc-1;
END;

PROCEDURE BJump(L: LONGINT);
BEGIN
  Put3(opBC, 7, L-pc-1)
END;

PROCEDURE CFJump(VAR x: Base.Item);
BEGIN
  IF x.mode <> mCond THEN loadCond(x);
  Put3(opBC, negated(x.r), x.a);
  FixLink(x.b); x.a := pc-1
END;

PROCEDURE CBJump(VAR x: Base.Item; L: LONGINT);
BEGIN
  IF x.mode <> mCond THEN loadCond(x);
  Put3(opBC, negated(x.r), L-pc-1);
  FixLink(x.b);
  FixLinkWith(x.a, L)
END;

PROCEDURE For0(VAR x, y: Base.Item);
BEGIN
  Load(y)
END;

PROCEDURE For1(VAR x, y, z, w: Base.Item; VAR L: LONGINT);
BEGIN
  IF z.mode = Base.cConst THEN
    Put1a(opCmp, RH, y.r, z.a)
  ELSE BEGIN
    Load(z);
    Put0(opCmp, RH-1, y.r, z.r);
    DEC(RH)
  END ;
  L := pc;
  IF w.a > 0 THEN
    Put3(opBC, opGT, 0)
  ELSE IF w.a < 0 THEN
    Put3(opBC, opLT, 0)
  ELSE BEGIN
    Base.Mark('zero increment');
    Put3(opBC, opMI, 0)
  END;
  Store(x, y);
END;

PROCEDURE For2(VAR x, y, w: Base.Item);
BEGIN
  Load(x);
  DEC(RH);
  Put1a(opAdd, x.r, x.r, w.a)
END;

PROCEDURE SaveRegs(r: LONGINT);
VAR
  r0: LONGINT;
BEGIN
  r0 := 0;
  Put1(opSub, SP, SP, r*4);
  INC(frame, 4*r);
  REPEAT
    Put2(opStr, r0, SP, (r-r0-1)*4);
    INC(r0)
  UNTIL r0 = r;
END;

PROCEDURE RestoreRegs(r: LONGINT);
VAR
  r0: LONGINT;
BEGIN
  r0 := r;
  REPEAT
    DEC(r0);
    Put2(opLdr, r0, SP, (r-r0-1)*4)
  UNTIL r0 = 0;
  Put1(opAdd, SP, SP, r*4);
  DEC(frame, 4*r)
END;

PROCEDURE PrepCall(VAR x: Base.Item; VAR r: LONGINT);
BEGIN
  IF x.mode > Base.cPar THEN Load(x);
  r := RH;
  IF RH > 0 THEN BEGIN
    SaveRegs(RH);
    RH := 0
  END;
END;

PROCEDURE Call(VAR x: Base.Item; r: LONGINT);
BEGIN
  IF x.mode = Base.cConst THEN BEGIN
    IF x.r >= 0 THEN
      Put3(opBL, 7, _DIV(x.a,4)-pc-1)
    ELSE BEGIN
      IF pc - fixorgP < $1000 THEN BEGIN
        Put3(opBL, 7, ((-x.r) * $100 + x.a) * $1000 + pc-fixorgP);
        fixorgP := pc-1
      END ELSE
        Base.Mark('fixup impossible');
    END;
  END ELSE BEGIN
    IF x.mode <= Base.cPar THEN BEGIN
      Load(x);
      DEC(RH);
    END ELSE BEGIN
      Put2(opLdr, RH, SP, 0);
      Put1(opAdd, SP, SP, 4);
      DEC(r);
      DEC(frame, 4)
    END;
    IF check THEN Trap(opEQ, 5);
    Put3(opBLR, 7, RH);
  END;
  IF x.typ.base.form = Base.fNoTyp THEN
    RH := 0
  ELSE BEGIN
    IF r > 0 THEN BEGIN
      Put0(opMov, r, 0, 0);
      RestoreRegs(r)
    END;
    x.mode := Reg;
    x.r := r;
    RH := r+1;
  END;
  invalSB;
END;

PROCEDURE Store(VAR x, y: Base.Item);
VAR
  op: LONGINT;
BEGIN

  Load(y);

  IF x.typ.size = 1 THEN
    op := opStr+1
  ELSE
    op := opStr;

  IF x.mode = Base.cVar THEN BEGIN
    IF x.r > 0 THEN
      Put2(op, y.r, SP, x.a + frame)
    ELSE BEGIN
      GetSB(x.r);
      Put2(op, y.r, SB, x.a);
    END;
  END ELSE IF x.mode = Base.cPar THEN BEGIN
    Put2(opLdr, RH, SP, x.a + frame);
    Put2(op, y.r, RH, x.b);
  END ELSE IF x.mode = RegI THEN BEGIN
    Put2(op, y.r, x.r, x.a);
    DEC(RH);
  END ELSE
    Base.Mark('bad mode in Store');

  DEC(RH);

END;

PROCEDURE StoreStruct(VAR x, y: Base.Item);
VAR
  s, pc0: LONGINT;
BEGIN
  IF y.typ.size <> 0 THEN BEGIN
    LoadAdr(x);
    LoadAdr(y);
    IF (x.typ.form = Base.fArray) AND (x.typ.len > 0) THEN BEGIN
      IF y.typ.len >= 0 THEN BEGIN
        IF x.typ.size = y.typ.size THEN
          Put1a(opMov, RH, 0, _DIV(y.typ.size+3,4))
        ELSE
          Base.Mark('different length/size, not implemented')
      END ELSE BEGIN
        Put2(opLdr, RH, SP, y.a+4);
        s := y.typ.base.size;
        pc0 := pc;
        Put3(opBC, opEQ, 0);
        IF s = 1 THEN BEGIN
          Put1(opAdd, RH, RH, 3);
          Put1(opAsr, RH, RH, 2)
        END ELSE IF s <> 4 THEN
          Put1a(opMul, RH, RH, _DIV(s,4));
        IF check THEN BEGIN
          Put1a(opMov, RH+1, 0, _DIV(x.typ.size+3,4));
          Put0(opCmp, RH+1, RH, RH+1);
          Trap(opGT, 3)
        END;
        fix(pc0, pc + 5 - pc0)
      END;
    END ELSE IF x.typ.form = Base.fRecord THEN
      Put1a(opMov, RH, 0, _DIV(x.typ.size,4))
    ELSE
      Base.Mark('inadmissible assignment');
    Put2(opLdr, RH+1, y.r, 0);
    Put1(opAdd, y.r, y.r, 4);
    Put2(opStr, RH+1, x.r, 0);
    Put1(opAdd, x.r, x.r, 4);
    Put1(opSub, RH, RH, 1);
    Put3(opBC, opNE, -6)
  END;
  RH := 0;
END;

PROCEDURE Enter(parblksize, locblksize: LONGINT; int: BOOLEAN);
VAR
  a, r: LONGINT;
BEGIN
  invalSB;
  frame := 0;
  IF NOT int THEN BEGIN
    IF locblksize >= $10000 THEN Base.Mark('too many locals');
    a := 4;
    r := 0;
    Put1(opSub, SP, SP, locblksize);
    Put2(opStr, LNK, SP, 0);
    WHILE a < parblksize DO BEGIN
      Put2(opStr, r, SP, a);
      INC(r);
      INC(a, 4)
    END;
  END ELSE BEGIN
    IF locblksize > 0 THEN Base.Mark('locals not allowed');
    Put1(opSub, SP, SP, 12);
    Put2(opStr, 0, SP, 0);
    Put2(opStr, 1, SP, 4);
    Put2(opStr, SB, SP, 8);
  END;
END;

PROCEDURE Return(form: INTEGER; VAR x: Base.Item; size: LONGINT; int: BOOLEAN);
BEGIN
  IF form <> Base.fNoTyp THEN load(x);
  IF NOT int THEN BEGIN
    Put2(opLdr, LNK, SP, 0);
    Put1(opAdd, SP, SP, size);
    Put3(opBR, 7, LNK)
  END ELSE BEGIN
    Put2(opLdr, SB, SP, 8);
    Put2(opLdr, 1, SP, 4);
    Put2(opLdr, 0, SP, 0);
    Put1(opAdd, SP, SP, 12);
    Put3(opBR, 7, $10);
  END;
  RH := 0;
END;

PROCEDURE Open(v: INTEGER);
BEGIN
  pc := 0;
  tdx := 0;
  strx := 0;
  RH := 0;
  fixorgP := 0;
  fixorgD := 0;
  fixorgT := 0;
  check := v <> 0;
  version := v;
  IF v = 0 THEN BEGIN
    pc := 1;
    REPEAT
      code[pc] := 0;
      INC(pc)
    UNTIL pc = 8;
  END;
END;

PROCEDURE Header;
BEGIN
  entry := pc*4;
  IF version = 0 THEN BEGIN
    code[0] := $0E7000000-1 + pc;
    Put1a(opMov, SB, 0, VarOrg0);
    Put1a(opMov, SP, 0, StkOrg0);
  END ELSE BEGIN
    Put1(opSub, SP, SP, 4);
    Put2(opStr, LNK, SP, 0);
    invalSB;
  END;
END;

FUNCTION NofPtrs(typ: Base.Type_): LONGINT;
VAR
  fld: Base.Object_;
  n: LONGINT;
BEGIN
  IF (typ.form = Base.fPointer) OR (typ.form = Base.fNilTyp) THEN
    n := 1
  ELSE IF typ.form = Base.fRecord THEN BEGIN
    fld := typ.dsc;
    n := 0;
    WHILE fld <> NIL DO BEGIN
      n := NofPtrs(fld.typ) + n;
      fld := fld.next
    END;
  END ELSE IF typ.form = Base.fArray THEN
    n := NofPtrs(typ.base) * typ.len
  ELSE
    n := 0;
  RESULT := n;
END;

PROCEDURE Close(AName: Base.TStrings; VAR modid: Base.TIdent; key, nofent: LONGINT);
VAR
  obj: Base.Object_;
  i, comsize, nofimps, vnofptrs, size: LONGINT;
  d: Files.RscData;
BEGIN

  IF version = 0 THEN BEGIN
    Put1(opMov, 0, 0, 0);
    Put3(opBR, 7, 0);
  END ELSE BEGIN
    Put2(opLdr, LNK, SP, 0);
    Put1(opAdd, SP, SP, 4);
    Put3(opBR, 7, LNK);
  END;

  obj     := Base.topScope.next;
  nofimps := 0;
  comsize := 4;
  vnofptrs := 0;

  WHILE obj <> NIL DO BEGIN
    IF (obj.clas = Base.cMod) AND (obj.dsc <> Base.vsystem) THEN
      INC(nofimps)
    ELSE IF (obj.exno <> 0) AND (obj.clas = Base.cConst) AND (obj.typ.form = Base.fProc)
    AND (obj.typ.nofpar = 0) AND (obj.typ.base = Base.noType) THEN BEGIN
      i := 0;
      WHILE obj.name[i] <> #0 DO INC(i);
      i := _DIV(i+4,4) * 4;
      INC(comsize, i+4)
    END ELSE IF obj.clas = Base.cVar THEN
      INC(vnofptrs, NofPtrs(obj.typ));
    obj := obj.next;
  END ;
  size := varsize + strx + comsize + (pc + nofimps + nofent + vnofptrs + 1)*4;

  d.data    := @data[0];
  d.str     := @str[0];
  d.code    := @code[0];
  d.entry   := entry;
  d.pc      := pc;
  d.varsize := varsize;
  d.strx    := strx;
  d.tdx     := tdx;
  d.size    := size;
  d.key     := key;
  d.nofent  := nofent;
  d.fixorgP := fixorgP;
  d.fixorgD := fixorgD;
  d.fixorgT := fixorgT;

  Files.CreateRsc(AName,modid,d);

END;

PROCEDURE Q(T: Base.Type_; VAR dcw: LONGINT);
BEGIN
  IF T.base <> NIL THEN BEGIN
    Q(T.base, dcw);
    data[dcw] := (T.mno*$1000 + T.len) * $1000 + dcw - fixorgT;
    fixorgT := dcw;
    INC(dcw);
  END;
END;

PROCEDURE CopyString(VAR x, y: Base.Item);
VAR
  len: LONGINT;
BEGIN
  loadAdr(x);
  len := x.typ.len;

  IF len >= 0 THEN BEGIN
    IF len <  y.b THEN Base.Mark('string too long');
  END ELSE IF check THEN BEGIN
    Put2(opLdr, RH, SP, x.a+4);
    Put1(opCmp, RH, RH, y.b);
    Trap(opLT, 3)
  END ;
  loadStringAdr(y);
  Put2(opLdr, RH, y.r, 0);
  Put1(opAdd, y.r, y.r, 4);
  Put2(opStr, RH, x.r, 0);
  Put1(opAdd, x.r, x.r, 4);
  Put1(opAsr, RH, RH, 24);
  Put3(opBC, opNE,  -6);
  RH := 0

END;

PROCEDURE DeRef(VAR x: Base.Item);
BEGIN
  IF x.mode = Base.cVar THEN BEGIN
    IF x.r > 0 THEN
      Put2(opLdr, RH, SP, x.a + frame)
    ELSE BEGIN
      GetSB(x.r);
      Put2(opLdr, RH, SB, x.a);
    END;
    NilCheck;
    x.r := RH;
    incR;
  END ELSE IF x.mode = Base.cPar THEN BEGIN
    Put2(opLdr, RH, SP, x.a + frame);
    Put2(opLdr, RH, RH, x.b);
    NilCheck;
    x.r := RH;
    incR;
  END ELSE IF x.mode = RegI THEN BEGIN
    Put2(opLdr, x.r, x.r, x.a);
    NilCheck;
  END ELSE IF x.mode <> Reg THEN
    Base.Mark('bad mode in DeRef');
  x.mode := RegI;
  x.a := 0;
  x.b := 0;
END;

PROCEDURE TypeTest(VAR x: Base.Item; T: Base.Type_; varpar, isguard: BOOLEAN);
VAR
  pc0: LONGINT;
BEGIN
  IF varpar THEN
    Put2(opLdr, RH, SP, x.a+4+frame)
  ELSE BEGIN
    load(x);
    pc0 := pc; Put3(opBC, opEQ, 0);
    Put2(opLdr, RH, x.r, -8)
  END;
  Put2(opLdr, RH, RH, T.nofpar*4); incR;
  loadTypTagAdr(T);
  Put0(opCmp, RH-1, RH-1, RH-2);
  DEC(RH, 2);
  IF NOT varpar THEN fix(pc0, pc - pc0 - 1);
  IF isguard THEN BEGIN
    IF check THEN Trap(opNE, 2);
  END ELSE BEGIN
    SetCC(x, opEQ);
    IF NOT varpar THEN DEC(RH);
  END;
END;

PROCEDURE FindPtrFlds(typ: Base.Type_; off: LONGINT; VAR dcw: LONGINT);
VAR
  fld: Base.Object_;
  i, s: LONGINT;
BEGIN
  IF (typ.form = Base.fPointer) OR (typ.form = Base.fNilTyp) THEN BEGIN
    data[dcw] := off;
    INC(dcw)
  END ELSE IF typ.form = Base.fRecord THEN BEGIN
    fld := typ.dsc;
    WHILE fld <> NIL DO BEGIN
      FindPtrFlds(fld.typ, fld.val + off, dcw);
      fld := fld.next;
    END;
  END ELSE IF typ.form = Base.fArray THEN BEGIN
    s := typ.base.size;
    FOR i := 0 TO typ.len-1 DO FindPtrFlds(typ.base, i*s + off, dcw);
  END;
END;

PROCEDURE BuildTD(T: Base.Type_; VAR dc: LONGINT);
VAR
  dcw, k, s: LONGINT;
BEGIN
  dcw := _DIV(dc,4);
  s := T.size;
  IF      s <= 24 THEN s := 32
  ELSE IF s <= 56 THEN s := 64
  ELSE IF s <= 120 THEN s := 128
  ELSE    s := _DIV(s+263,256) * 256;
  T.len := dc;
  data[dcw] := s;
  INC(dcw);
  k := T.nofpar;
  IF k > 3 THEN
    Base.Mark('ext level too large')
  ELSE BEGIN
    Q(T, dcw);
    WHILE k < 3 DO BEGIN
      data[dcw] := -1;
      INC(dcw);
      INC(k)
    END;
  END;
  FindPtrFlds(T, 0, dcw);
  data[dcw] := -1;
  INC(dcw);
  tdx := dcw;
  dc := dcw*4;
  IF tdx >= maxTD THEN BEGIN
    Base.Mark('too many record types');
    tdx := 0
  END;
END;

PROCEDURE SetDataSize(dc: LONGINT);
BEGIN
  varsize := dc;
END;

(**********)
(**********)
(**********)
(**********)
(**********)

PROCEDURE fIncrement(upordown: LONGINT; VAR x, y: Base.Item);
VAR
  op, zr, v: LONGINT;
BEGIN
  IF upordown = 0 THEN
    op := opAdd
  ELSE
    op := opSub;

  IF x.typ = Base.byteType THEN v := 1 ELSE v := 0;

  IF y.typ.form = Base.fNoTyp THEN BEGIN
    y.mode := Base.cConst;
    y.a := 1
  END;

  IF (x.mode = Base.cVar) AND (x.r > 0) THEN BEGIN
    zr := RH;
    Put2(opLdr+v, zr, SP, x.a);
    incR;
    IF y.mode = Base.cConst THEN
      Put1a(op, zr, zr, y.a)
    ELSE BEGIN
      load(y);
      Put0(op, zr, zr, y.r);
      DEC(RH)
    END;
    Put2(opStr+v, zr, SP, x.a);
    DEC(RH)
  END ELSE BEGIN
    loadAdr(x);
    zr := RH;
    Put2(opLdr+v, RH, x.r, 0);
    incR;
    IF y.mode = Base.cConst THEN
      Put1a(op, zr, zr, y.a)
    ELSE BEGIN
      load(y);
      Put0(op, zr, zr, y.r);
      DEC(RH)
    END;
    Put2(opStr+v, zr, x.r, 0);
    DEC(RH, 2)
  END;
END;

PROCEDURE fInclude(inorex: LONGINT; VAR x, y: Base.Item);
VAR
  op, zr: LONGINT;
BEGIN
  loadAdr(x);
  zr := RH;
  Put2(opLdr, RH, x.r, 0);
  incR;
  IF inorex = 0 THEN op := opIor ELSE op := opAnn;
  IF y.mode = Base.cConst THEN
    Put1a(op, zr, zr, LSL(1, y.a))
  ELSE BEGIN
    load(y);
    Put1(opMov, RH, 0, 1);
    Put0(opLsl, y.r, RH, y.r);
    Put0(op, zr, zr, y.r);
    DEC(RH);
  END;
  Put2(opStr, zr, x.r, 0);
  DEC(RH, 2);
END;

PROCEDURE fAssert(VAR x: Base.Item);
VAR
  cond: LONGINT;
BEGIN
  IF x.mode <> mCond THEN loadCond(x);
  IF x.a = 0 THEN
    cond := negated(x.r)
  ELSE BEGIN
    Put3(opBC, x.r, x.b);
    FixLink(x.a);
    x.b := pc-1;
    cond := 7;
  END;
  Trap(cond, 7);
  FixLink(x.b);
END;

PROCEDURE fNew(VAR x: Base.Item);
BEGIN
  loadAdr(x);
  loadTypTagAdr(x.typ.base);
  Trap(7, 0);
  RH := 0;
  invalSB;
END;

PROCEDURE fPack(VAR x, y: Base.Item);
VAR
  z: Base.Item;
BEGIN
  z := x;
  load(x);
  load(y);
  Put1(opLsl, y.r, y.r, 23);
  Put0(opAdd, x.r, x.r, y.r);
  DEC(RH);
  Store(z, x);
END;

PROCEDURE fUnpk(VAR x, y: Base.Item);
VAR
  z, e0: Base.Item;
BEGIN
  z := x;
  load(x);
  e0.mode := Reg;
  e0.r := RH;
  e0.typ := Base.intType;
  Put1(opAsr, RH, x.r, 23);
  Put1(opSub, RH, RH, 127);
  Store(y, e0);
  incR;
  Put1(opLsl, RH, RH, 23);
  Put0(opSub, x.r, x.r, RH);
  Store(z, x);
END;

PROCEDURE fLed(VAR x: Base.Item);
BEGIN
  load(x);
  Put1(opMov, RH, 0, -60);
  Put2(opStr, x.r, RH, 0);
  DEC(RH);
END;

PROCEDURE fGet(VAR x, y: Base.Item);
BEGIN
  load(x);
  x.typ := y.typ;
  x.mode := RegI;
  x.a := 0;
  Store(y, x);
END;

PROCEDURE fPut(VAR x, y: Base.Item);
BEGIN
  load(x);
  x.typ := y.typ;
  x.mode := RegI;
  x.a := 0;
  Store(x, y);
END;

PROCEDURE fCopy(VAR x, y, z: Base.Item);
BEGIN
  load(x);
  load(y);
  IF z.mode = Base.cConst THEN BEGIN
    IF z.a > 0 THEN
      load(z)
    ELSE
      Base.Mark('bad count');
  END ELSE BEGIN
    load(z);
    IF check THEN Trap(opLT, 3);
    Put3(opBC, opEQ, 6)
  END;
  Put2(opLdr, RH, x.r, 0);
  Put1(opAdd, x.r, x.r, 4);
  Put2(opStr, RH, y.r, 0);
  Put1(opAdd, y.r, y.r, 4);
  Put1(opSub, z.r, z.r, 1);
  Put3(opBC, opNE, -6);
  DEC(RH, 3)
END;

PROCEDURE fLDPSR(VAR x: Base.Item);
BEGIN
  Put3(0, 15, x.a + $20)
END;

PROCEDURE fLDREG(VAR x, y: Base.Item);
BEGIN
  IF y.mode = Base.cConst THEN
    Put1a(opMov, x.a, 0, y.a)
  ELSE BEGIN
    load(y);
    Put0(opMov, x.a, 0, y.r);
    DEC(RH);
  END;
END;

PROCEDURE fAbs(VAR x: Base.Item);
BEGIN
  IF x.mode = Base.cConst THEN
    x.a := SYSTEM.ABS(x.a)
  ELSE BEGIN
    load(x);
    IF x.typ.form = Base.fReal THEN BEGIN
      Put1(opLsl, x.r, x.r, 1);
      Put1(opRor, x.r, x.r, 1);
    END ELSE BEGIN
      Put1(opCmp, x.r, x.r, 0);
      Put3(opBC, opGE, 2);
      Put1(opMov, RH, 0, 0);
      Put0(opSub, x.r, RH, x.r);
    END;
  END;
END;

PROCEDURE fOdd(VAR x: Base.Item);
BEGIN
  load(x);
  Put1(opAnd, x.r, x.r, 1);
  SetCC(x, opNE);
  DEC(RH)
END;

PROCEDURE fFloor(VAR x: Base.Item);
BEGIN
  load(x);
  Put1(opMov+U, RH, 0, $4B00);
  Put0(opFad+V, x.r, x.r, RH)
END;

PROCEDURE fFloat(VAR x: Base.Item);
BEGIN
  load(x);
  Put1(opMov+U, RH, 0, $4B00);
  Put0(opFad+U, x.r, x.r, RH)
END;

PROCEDURE fOrd(VAR x: Base.Item);
BEGIN
  IF x.mode IN [Base.cVar, Base.cPar, RegI, mCond] THEN load(x);
END;

PROCEDURE fLen(VAR x: Base.Item);
BEGIN
  IF x.typ.len >= 0 THEN BEGIN
    IF x.mode = RegI THEN DEC(RH);
    x.mode := Base.cConst;
    x.a := x.typ.len;
  END ELSE BEGIN
    Put2(opLdr, RH, SP, x.a + 4 + frame);
    x.mode := Reg;
    x.r := RH;
    incR;
  END;
END;

PROCEDURE fShift(fct: LONGINT; VAR x, y: Base.Item);
VAR
  op: LONGINT;
BEGIN
  load(x);

  IF fct = 0 THEN
    op := opLsl
  ELSE IF fct = 1 THEN
    op := opAsr
  ELSE
    op := opRor;

  IF y.mode = Base.cConst THEN
    Put1(op, x.r, x.r, _MOD(y.a,$20))
  ELSE BEGIN
    load(y);
    Put0(op, RH-2, x.r, y.r);
    DEC(RH);
    x.r := RH-1;
  END;
END;

PROCEDURE fADC(VAR x, y: Base.Item);
BEGIN
  load(x);
  load(y);
  Put0(opAdd+$2000, x.r, x.r, y.r);
  DEC(RH)
END;

PROCEDURE fSBC(VAR x, y: Base.Item);
BEGIN
  load(x);
  load(y);
  Put0(opSub+$2000, x.r, x.r, y.r);
  DEC(RH)
END;

PROCEDURE fUML(VAR x, y: Base.Item);
BEGIN
  load(x);
  load(y);
  Put0(opMul+$2000, x.r, x.r, y.r);
  DEC(RH);
END;

PROCEDURE fBit(VAR x, y: Base.Item);
BEGIN
  load(x);
  Put2(opLdr, x.r, x.r, 0);
  IF y.mode = Base.cConst THEN BEGIN
    Put1(opRor, x.r, x.r, y.a+1);
    DEC(RH)
  END ELSE BEGIN
    load(y);
    Put1(opAdd, y.r, y.r, 1);
    Put0(opRor, x.r, x.r, y.r);
    DEC(RH, 2)
  END;
  SetCC(x, opMI);
END;

PROCEDURE fRegister(VAR x: Base.Item);
BEGIN
  Put0(opMov, RH, 0, _MOD(x.a,$10));
  x.mode := Reg;
  x.r := RH;
  incR;
END;

PROCEDURE fH(VAR x: Base.Item);
BEGIN
  Put0(opMov + U + _MOD(x.a,2) * V, RH, 0, 0);
  x.mode := Reg;
  x.r := RH;
  incR;
END;

PROCEDURE fAdr(VAR x: Base.Item);
BEGIN
  IF       x.mode IN [Base.cVar, Base.cPar, RegI]                THEN loadAdr(x)
  ELSE IF (x.mode = Base.cConst) AND (x.typ.form = Base.fProc)   THEN load(x)
  ELSE IF (x.mode = Base.cConst) AND (x.typ.form = Base.fString) THEN loadStringAdr(x)
  ELSE
    Base.Mark('not addressable');
END;

PROCEDURE fCondition(VAR x: Base.Item);
BEGIN
  SetCC(x, x.a)
END;

BEGIN
  relmap[0] := 1;
  relmap[1] := 9;
  relmap[2] := 5;
  relmap[3] := 6;
  relmap[4] := 14;
  relmap[5] := 13
END.

